clc;
load('spd_matrix.mat');

n = length(A);
x = zeros(n,1);
tol = 1e-9;
r = b-A*x;
d = r;
beta = 1;
iterationen = 0;
norm_alt = norm(r)^2;
maxit = 100;

for i = 0:maxit
    disp(iterationen)
    r_alt = r;
    Ad = A * d;
    alpha = norm(r)^2 / (d' * Ad);
    x = x + alpha * d;
    r = r - alpha * Ad;
    norm_neu = norm(r)^2;
    beta = norm_neu / norm_alt;
    if (norm(r) < tol)
        break;
    end
    norm_alt = norm_neu;
    d = r + beta * d;
    iterationen = iterationen + 1;
end